// Practica2.7 de opengl


/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/

#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>
#include<math.h>
#include<iostream.h>
#include<stdio.h>
#define DOS_PI 6.2628

// Mi_inicio
void myInit(void);

// estructura para los puntos.
struct GLfloatPoint{
	float x;
	float y;
};

void myInit(void)
{
		glClearColor(0.0,0.0,0.0,0.0); //Selecciona el color de fondo
		glColor3f(1.0f, 0.0f, 0.0f);  //El color a dibujar
		glPointSize(1.0);			//Tamao de los puntos
		glMatrixMode (GL_PROJECTION);
		glLoadIdentity();
		gluOrtho2D(0.0, 400.0, 0.0, 420.0);
}

// mi ventana!
void myDisplay(void) // Mi_Ventana 
{
glClear(GL_COLOR_BUFFER_BIT); // clear screen
}


void dibuja(GLfloatPoint S, float radio)
{
	GLfloat x,y,incre, theta=0;
	int n=100;
	incre=DOS_PI/(float)n; //castinggg
	for(int i=0; i<=n; i++)
	{
		theta+=incre;
		x=S.x+radio*cos(theta);
		y=S.y+radio*sin(theta);
		glBegin(GL_LINE_STRIP);
		glVertex2f(x,y);
	}
	glEnd();
	glFlush();
}


// funcion que calcula los valosres de radio y centro el triangulo
void triangulo(struct GLfloatPoint T[])
{
GLfloatPoint a,b,c,an,centro; // inicializa los tres puntos
float radio;
// calculamos las coordenadas de los vectores!
a.x=T[1].x - T[0].x;
a.y=T[1].y - T[0].y;
b.x=T[2].x - T[1].x;
b.y=T[2].y - T[1].y;
c.x=T[0].x - T[2].x;
c.y=T[0].y - T[2].y;
// ahora las coordenadas del vector normal
an.x=-a.y;
an.y=a.x;
// calculating....
centro.x=T[0].x+0.5*(a.x+b.x+b.y*c.y)/((an.x*c.x+an.y*c.y)*an.x);
centro.y=T[0].y+0.5*(a.y+b.y+b.x*c.x)/((an.y*c.x+an.x*c.x)*an.y);
// esto de abajo creo que esta mal. revisar
radio=0.5*sqrt(a.x*a.x+a.y*a.y)*sqrt((b.x*c.x+b.y*c.y)/(an.x*c.x+an.y*c.y)+1);
// lo siento el radio hace pegoletes :-P
glFlush();
}

// funcion que dibuja los puntos!
void drawDot(float x , float y)
{
glBegin(GL_POINTS);
glVertex2f(x,y);
glEnd();

}



/// __________________________
// funcion del raton

void raton(int button, int state, int x, int y)
{
static GLfloatPoint corner[3];
static int numCorners=0;
int Anchopantalla=420;
if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
	{
	corner[numCorners].x=x;
	corner[numCorners].y=Anchopantalla-y;
	numCorners++;
	if(numCorners==3)
		{
		triangulo(corner);
		numCorners=0;
		}
	}
else if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
	{
	glClear(GL_COLOR_BUFFER_BIT);
	}
}

// MAIN
void main (int argc, char** argv)
{
glutInit(&argc, argv); //Inicializa toolkit
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //Selecciona el modo pantalla
  glutInitWindowSize(400,420);	//Selecciona el tamao de la ventana
  glutInitWindowPosition(100, 150); //Posiciona la ventana en la pantalla
  glutCreateWindow("Practica 2.2");//Abre la ventana
  glutDisplayFunc(myDisplay); //Registra la funcin de redibujar
  myInit();
  glutMouseFunc(raton);  
  glutMainLoop(); //Bucle continuo
}